kdecore Library: KNetwork::KSocketDevice Class Reference (kdecore Library)

| # kdecore Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KNetwork::KSocketDevice Class Reference

Low-level socket functionality. More...

`#include <ksocketdevice.h>`

Inheritance diagram for KNetwork::KSocketDevice:

[legend]
Collaboration diagram for KNetwork::KSocketDevice:

[legend]
List of all members.

## Public Types
enum | Capabilities { CanConnectString = 0x01, CanBindString = 0x02, CanNotBind = 0x04, CanNotListen = 0x08, CanMulticast = 0x10, CanNotUseDatagrams = 0x20 }
## Public Member Functions
| KSocketDevice (const KSocketBase *=0L)
| KSocketDevice (int fd)
virtual | ~KSocketDevice ()
int | socket () const
virtual int | capabilities () const
virtual bool | setSocketOptions (int opts)
virtual bool | open (int mode)
virtual void | close ()
virtual void | flush ()
virtual bool | create (int family, int type, int protocol)
bool | create (const KResolverEntry &address)
virtual bool | bind (const KResolverEntry &address)
virtual bool | listen (int backlog=5)
virtual bool | connect (const KResolverEntry &address)
virtual KSocketDevice * | accept ()
virtual bool | disconnect ()
virtual Q_LONG | bytesAvailable () const
virtual Q_LONG | waitForMore (int msecs, bool *timeout=0L)
virtual Q_LONG | readBlock (char *data, Q_ULONG maxlen)
virtual Q_LONG | readBlock (char *data, Q_ULONG maxlen, KSocketAddress &from)
virtual Q_LONG | peekBlock (char *data, Q_ULONG maxlen)
virtual Q_LONG | peekBlock (char *data, Q_ULONG maxlen, KSocketAddress &from)
virtual Q_LONG | writeBlock (const char *data, Q_ULONG len)
virtual Q_LONG | writeBlock (const char *data, Q_ULONG len, const KSocketAddress &to)
virtual KSocketAddress | localAddress () const
virtual KSocketAddress | peerAddress () const
virtual KSocketAddress | externalAddress () const
QSocketNotifier * | readNotifier () const
QSocketNotifier * | writeNotifier () const
QSocketNotifier * | exceptionNotifier () const
virtual bool | poll (bool *input, bool *output, bool *exception=0L, int timeout=-1, bool *timedout=0L)
bool | poll (int timeout=-1, bool *timedout=0L)
## Static Public Member Functions
static KSocketDevice * | createDefault (KSocketBase *parent)
static KSocketDevice * | createDefault (KSocketBase *parent, int capabilities)
static KSocketDeviceFactoryBase * | setDefaultImpl (KSocketDeviceFactoryBase *factory)
static void | addNewImpl (KSocketDeviceFactoryBase *factory, int capabilities)
## Protected Member Functions
| KSocketDevice (bool, const KSocketBase *parent=0L)
virtual QSocketNotifier * | createNotifier (QSocketNotifier::Type type) const
## Protected Attributes
int | m_sockfd

## Detailed Description

Low-level socket functionality.

This class provides low-level socket functionality.

Most users will prefer "cooked" interfaces like those of KStreamSocket or KServerSocket.

Descended classes from this one provide some other kinds of socket functionality, like proxying or specific socket types.

Author:
  Thiago Macieira <thiago.macieira@kdemail.net>

Definition at line 50 of file ksocketdevice.h.

## Member Enumeration Documentation

enum KNetwork::KSocketDevice::Capabilities

  | Capabilities for the socket implementation. KSocketDevice-derived classes can implement certain capabilities that are not available in the default class. These capabilities are described by these flags. The default KSocketDevice class has none of these capabilities. For the negative capabilities (inabilities, the CanNot* forms), when a capability is not present, the implementation will default to the original behaviour. Enumeration values:
  CanConnectString | Can connect to hostnames. If this flag is present, the string form of connect can be used.
  CanBindString | Can bind to hostnames. If this flag is present, the string form of bind can be used
  CanNotBind | Can not bind. If this flag is present, this implementation cannot bind
  CanNotListen | Can not listen. If this flag is present, this implementation cannot listen
  CanMulticast | Can send multicast as well as join/leave multicast groups.
  CanNotUseDatagrams | Can not use datagrams. Note that this implies multicast capability not being available either.
Definition at line 63 of file ksocketdevice.h.

## Constructor & Destructor Documentation

KSocketDevice::KSocketDevice | ( | const KSocketBase * | = `0L` | ) | `[explicit]`

| Default constructor. The parameter is used to specify which socket this object is used as a device for. Definition at line 76 of file ksocketdevice.cpp. References KNetwork::KSocketBase::setSocketDevice(), and setSocketOptions(). Referenced by accept(), and createDefault().

KSocketDevice::KSocketDevice | ( | int | fd | ) | `[explicit]`

| Constructs a new object around an already-open socket. Note: you should write programs that create sockets through the classes whenever possible. Definition at line 84 of file ksocketdevice.cpp. References KNetwork::KSocketBase::setSocketDevice().

KSocketDevice::~KSocketDevice | ( |  | ) | `[virtual]`

| Destructor. This closes the socket if it's open. Definition at line 100 of file ksocketdevice.cpp. References close().

KSocketDevice::KSocketDevice | ( | bool | ,
|  | const KSocketBase * | parent = `0L`
| ) | `[protected]`

  | Special constructor. This constructor will cause the internal socket device NOT to be set. Use this if your socket device class takes another underlying socket device. Parameters:
  | parent | the parent, if any
Definition at line 92 of file ksocketdevice.cpp. References setSocketOptions().

## Member Function Documentation

int KNetwork::KSocketDevice::socket | ( |  | ) | const`[inline]`

| Returns the file descriptor for this socket. Definition at line 122 of file ksocketdevice.h. References m_sockfd.

virtual int KNetwork::KSocketDevice::capabilities | ( |  | ) | const`[inline, virtual]`

| Returns the set of capabilities this socket class implements. The set of capabilities is defined as an OR-ed mask of Capabilities bits. The default implementation is guaranteed to always return 0. That is, derived implementations always return bits where they differ from the system standard sockets. Reimplemented in KNetwork::KHttpProxySocketDevice, KNetwork::KMulticastSocketImpl, and KNetwork::KSocksSocketDevice. Definition at line 134 of file ksocketdevice.h.

bool KSocketDevice::setSocketOptions | ( | int | opts | ) | `[virtual]`

| This implementation sets the options on the socket. Reimplemented from KNetwork::KSocketBase. Definition at line 107 of file ksocketdevice.cpp. References m_sockfd, KNetwork::KSocketBase::mutex(), and KNetwork::KActiveSocketBase::setError(). Referenced by create(), KSocketDevice(), KNetwork::KServerSocket::setSocketOptions(), and KNetwork::KClientSocketBase::setSocketOptions().

bool KSocketDevice::open | ( | int | mode | ) | `[virtual]`

| Reimplementation from QIODevice. You should not call this function in sockets. Reimplemented from QIODevice. Definition at line 171 of file ksocketdevice.cpp. References KNetwork::KActiveSocketBase::resetError().

void KSocketDevice::close | ( |  | ) | `[virtual]`

| Closes the socket. Reimplemented from QIODevice. Use this function to close the socket this object is holding open. Implements KNetwork::KPassiveSocketBase. Reimplemented in KNetwork::KHttpProxySocketDevice. Definition at line 177 of file ksocketdevice.cpp. References m_sockfd, and KNetwork::KActiveSocketBase::resetError(). Referenced by KNetwork::KServerSocket::close(), KNetwork::KClientSocketBase::close(), and ~KSocketDevice().

virtual void KNetwork::KSocketDevice::flush | ( |  | ) | `[inline, virtual]`

| This call is not supported on sockets. Reimplemented from QIODevice. Reimplemented from QIODevice. Definition at line 157 of file ksocketdevice.h.

bool KSocketDevice::create | ( | int | family,
|  | int | type,
|  | int | protocol
| ) | `[virtual]`

| Creates a socket but don't connect or bind anywhere. This function is the equivalent of the system call socket(2). Reimplemented in KNetwork::KMulticastSocketImpl. Definition at line 195 of file ksocketdevice.cpp. References m_sockfd, KNetwork::KActiveSocketBase::resetError(), KNetwork::KActiveSocketBase::setError(), setSocketOptions(), and KNetwork::KSocketBase::socketOptions(). Referenced by KNetwork::KSocksSocketDevice::bind(), bind(), KNetwork::KSocksSocketDevice::connect(), connect(), create(), and createDefault().

bool KSocketDevice::create | ( | const KResolverEntry & | address | ) |

| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Creates a socket but don't connect or bind anywhere. Definition at line 220 of file ksocketdevice.cpp. References create().

bool KSocketDevice::bind | ( | const KResolverEntry & | address | ) | `[virtual]`

| Binds this socket to the given address. Implements KNetwork::KActiveSocketBase. Reimplemented in KNetwork::KSocksSocketDevice. Definition at line 225 of file ksocketdevice.cpp. References create(), m_sockfd, KNetwork::KActiveSocketBase::resetError(), and KNetwork::KActiveSocketBase::setError().

bool KSocketDevice::listen | ( | int | backlog = `5` | ) | `[virtual]`

| Puts this socket into listening mode. Implements KNetwork::KPassiveSocketBase. Reimplemented in KNetwork::KSocksSocketDevice. Definition at line 248 of file ksocketdevice.cpp. References m_sockfd, KNetwork::KActiveSocketBase::resetError(), and KNetwork::KActiveSocketBase::setError().

bool KSocketDevice::connect | ( | const KResolverEntry & | address | ) | `[virtual]`

| Connect to a remote host. Implements KNetwork::KActiveSocketBase. Reimplemented in KNetwork::KHttpProxySocketDevice, KNetwork::KMulticastSocketImpl, and KNetwork::KSocksSocketDevice. Definition at line 270 of file ksocketdevice.cpp. References create(), m_sockfd, KNetwork::KActiveSocketBase::resetError(), and KNetwork::KActiveSocketBase::setError(). Referenced by KNetwork::KClientSocketBase::connect().

KSocketDevice * KSocketDevice::accept | ( |  | ) | `[virtual]`

| Accepts a new incoming connection. Note: this function returns a socket of type KSocketDevice. Implements KNetwork::KPassiveSocketBase. Reimplemented in KNetwork::KSocksSocketDevice. Definition at line 304 of file ksocketdevice.cpp. References KSocketDevice(), m_sockfd, and KNetwork::KActiveSocketBase::setError(). Referenced by KNetwork::KServerSocket::accept().

bool KSocketDevice::disconnect | ( |  | ) | `[virtual]`

| Disconnects this socket. Implements KNetwork::KActiveSocketBase. Definition at line 328 of file ksocketdevice.cpp. References KNetwork::KSocketAddress::address(), KNetwork::KSocketAddress::length(), m_sockfd, KNetwork::KActiveSocketBase::resetError(), KNetwork::KActiveSocketBase::setError(), and KNetwork::KSocketAddress::setFamily(). Referenced by KNetwork::KClientSocketBase::disconnect().

Q_LONG KSocketDevice::bytesAvailable | ( |  | ) | const`[virtual]`

| Returns the number of bytes available for reading without blocking. Implements KNetwork::KActiveSocketBase. Definition at line 362 of file ksocketdevice.cpp. References m_sockfd. Referenced by KNetwork::KClientSocketBase::bytesAvailable(), and waitForMore().

Q_LONG KSocketDevice::waitForMore | ( | int | msecs,
|  | bool * | timeout = `0L`
| ) | `[virtual]`

| Waits up to `msecs` for more data to be available on this socket. This function is a wrapper against poll. This function will wait for any read events. Implements KNetwork::KActiveSocketBase. Definition at line 374 of file ksocketdevice.cpp. References bytesAvailable(), m_sockfd, and poll(). Referenced by KNetwork::KDatagramSocket::receive(), and KNetwork::KClientSocketBase::waitForMore().

Q_LONG KSocketDevice::readBlock | ( | char * | data,
|  | Q_ULONG | maxlen
| ) | `[virtual]`

| Reads data from this socket. Implements KNetwork::KActiveSocketBase. Reimplemented in KNetwork::KSocksSocketDevice. Definition at line 412 of file ksocketdevice.cpp. Referenced by KNetwork::KClientSocketBase::readBlock().

Q_LONG KSocketDevice::readBlock | ( | char * | data,
|  | Q_ULONG | maxlen,
|  | KSocketAddress & | from
| ) | `[virtual]`

| Reads data and the source address from this socket. Implements KNetwork::KActiveSocketBase. Reimplemented in KNetwork::KSocksSocketDevice. Definition at line 433 of file ksocketdevice.cpp. References m_sockfd, KNetwork::KActiveSocketBase::resetError(), and KNetwork::KActiveSocketBase::setError().

Q_LONG KSocketDevice::peekBlock | ( | char * | data,
|  | Q_ULONG | maxlen
| ) | `[virtual]`

| Peeks data in the socket. Implements KNetwork::KActiveSocketBase. Reimplemented in KNetwork::KSocksSocketDevice. Definition at line 454 of file ksocketdevice.cpp. References m_sockfd, KNetwork::KActiveSocketBase::resetError(), and KNetwork::KActiveSocketBase::setError(). Referenced by KNetwork::KClientSocketBase::peekBlock().

Q_LONG KSocketDevice::peekBlock | ( | char * | data,
|  | Q_ULONG | maxlen,
|  | KSocketAddress & | from
| ) | `[virtual]`

| Peeks the data in the socket and the source address. Implements KNetwork::KActiveSocketBase. Reimplemented in KNetwork::KSocksSocketDevice. Definition at line 475 of file ksocketdevice.cpp. References m_sockfd, KNetwork::KActiveSocketBase::resetError(), and KNetwork::KActiveSocketBase::setError().

Q_LONG KSocketDevice::writeBlock | ( | const char * | data,
|  | Q_ULONG | len
| ) | `[virtual]`

| Writes data to the socket. Implements KNetwork::KActiveSocketBase. Reimplemented in KNetwork::KSocksSocketDevice. Definition at line 496 of file ksocketdevice.cpp. Referenced by KNetwork::KClientSocketBase::writeBlock().

Q_LONG KSocketDevice::writeBlock | ( | const char * | data,
|  | Q_ULONG | len,
|  | const KSocketAddress & | to
| ) | `[virtual]`

| Writes the given data to the given destination address. Implements KNetwork::KActiveSocketBase. Reimplemented in KNetwork::KSocksSocketDevice. Definition at line 501 of file ksocketdevice.cpp. References m_sockfd, KNetwork::KActiveSocketBase::resetError(), and KNetwork::KActiveSocketBase::setError().

KSocketAddress KSocketDevice::localAddress | ( |  | ) | const`[virtual]`

| Returns this socket's local address. Implements KNetwork::KActiveSocketBase. Reimplemented in KNetwork::KSocksSocketDevice. Definition at line 525 of file ksocketdevice.cpp. References KNetwork::KSocketAddress::address(), KNetwork::KSocketAddress::length(), localAddress(), m_sockfd, and KNetwork::KSocketAddress::setLength(). Referenced by externalAddress(), localAddress(), KNetwork::KServerSocket::localAddress(), and KNetwork::KClientSocketBase::localAddress().

KSocketAddress KSocketDevice::peerAddress | ( |  | ) | const`[virtual]`

| Returns this socket's peer address. If this implementation does proxying of some sort, this is the real external address, not the proxy's address. Implements KNetwork::KActiveSocketBase. Reimplemented in KNetwork::KHttpProxySocketDevice, and KNetwork::KSocksSocketDevice. Definition at line 554 of file ksocketdevice.cpp. References KNetwork::KSocketAddress::address(), KNetwork::KSocketAddress::length(), m_sockfd, peerAddress(), and KNetwork::KSocketAddress::setLength(). Referenced by peerAddress(), and KNetwork::KClientSocketBase::peerAddress().

KSocketAddress KSocketDevice::externalAddress | ( |  | ) | const`[virtual]`

| Returns this socket's externally visible local address. If this socket has a local address visible externally different from the normal local address (as returned by localAddress), then return it. Certain implementations will use proxies and thus have externally visible addresses different from the local socket values. The default implementation returns the same value as localAddress. Note: This function may return an empty KSocketAddress. In that case, the externally visible address could/can not be determined. Implements KNetwork::KPassiveSocketBase. Reimplemented in KNetwork::KHttpProxySocketDevice, and KNetwork::KSocksSocketDevice. Definition at line 583 of file ksocketdevice.cpp. References localAddress(). Referenced by KNetwork::KServerSocket::externalAddress().

QSocketNotifier * KSocketDevice::readNotifier | ( |  | ) | const

| Returns a socket notifier for input on this socket. The notifier is created only when requested. Whether it is enabled or not depends on the implementation. This function might return NULL. Definition at line 590 of file ksocketdevice.cpp. References createNotifier(), m_sockfd, and KNetwork::KSocketBase::mutex(). Referenced by KNetwork::KBufferedSocket::close(), KNetwork::KClientSocketBase::enableRead(), KNetwork::KBufferedSocket::enableRead(), and KNetwork::KClientSocketBase::stateChanging().

QSocketNotifier * KSocketDevice::writeNotifier | ( |  | ) | const

| Returns a socket notifier for output on this socket. The is created only when requested. This function might return NULL. Definition at line 608 of file ksocketdevice.cpp. References createNotifier(), m_sockfd, and KNetwork::KSocketBase::mutex(). Referenced by KNetwork::KClientSocketBase::enableWrite(), KNetwork::KBufferedSocket::enableWrite(), KNetwork::KBufferedSocket::slotWriteActivity(), KNetwork::KClientSocketBase::stateChanging(), and KNetwork::KBufferedSocket::writeBlock().

QSocketNotifier * KSocketDevice::exceptionNotifier | ( |  | ) | const

| Returns a socket notifier for exceptional events on this socket. The is created only when requested. This function might return NULL. Definition at line 626 of file ksocketdevice.cpp. References createNotifier(), m_sockfd, and KNetwork::KSocketBase::mutex().

bool KSocketDevice::poll | ( | bool * | input,
|  | bool * | output,
|  | bool * | exception = `0L`,
|  | int | timeout = `-1`,
|  | bool * | timedout = `0L`
| ) | `[virtual]`

  | Executes a poll in the socket, via select(2) or poll(2). The events polled are returned in the parameters pointers. Set any of them to NULL to disable polling of that event. On exit, `input`, `output` and `exception` will contain true if an event of that kind is waiting on the socket or false if not. If a timeout occurred, set `timedout` to true (all other parameters are necessarily set to false). Parameters:
  | input | if set, turns on polling for input events
  | output | if set, turns on polling for output events
  | exception | if set, turns on polling for exceptional events
  | timeout | the time in milliseconds to wait for an event; 0 for no wait and any negative value to wait forever
  | timedout | on exit, will contain true if the polling timed out
Returns: true if the poll call succeeded and false if an error occurred Reimplemented in KNetwork::KSocksSocketDevice. Definition at line 644 of file ksocketdevice.cpp. References m_sockfd, KNetwork::KActiveSocketBase::resetError(), and KNetwork::KActiveSocketBase::setError(). Referenced by KNetwork::KStreamSocket::connect(), poll(), and waitForMore().

bool KSocketDevice::poll | ( | int | timeout = `-1`,
|  | bool * | timedout = `0L`
| ) |

  | Shorter version to poll for any events in a socket. This call polls for input, output and exceptional events in a socket but does not return their states. This is useful if you need to wait for any event, but don't need to know which; or for timeouts. Parameters:
  | timeout | the time in milliseconds to wait for an event; 0 for no wait and any negative value to wait forever
  | timedout | on exit, will contain true if the polling timed out
Returns: true if the poll call succeeded and false if an error occurred Definition at line 766 of file ksocketdevice.cpp. References poll().

QSocketNotifier * KSocketDevice::createNotifier | ( | QSocketNotifier::Type | type | ) | const`[protected, virtual]`

  | Creates a socket notifier of the given type. This function is called by readNotifier, writeNotifier and exceptionNotifier when they need to create a socket notifier (i.e., the first call to those functions after the socket is open). After that call, those functions cache the socket notifier and will not need to call this function again. Reimplement this function in your derived class if your socket type requires a different kind of QSocketNotifier. The return value should be deleteable with delete. (close deletes them). Parameters:
  | type | the socket notifier type
Definition at line 772 of file ksocketdevice.cpp. References m_sockfd. Referenced by exceptionNotifier(), readNotifier(), and writeNotifier().

KSocketDevice * KSocketDevice::createDefault | ( | KSocketBase * | parent | ) | `[static]`

  | Creates a new default KSocketDevice object given the parent object. The capabilities flag indicates the desired capabilities the object being created should possess. Those capabilities are not guaranteed: if no factory can provide such an object, a default object will be created. Parameters:
  | parent | the KSocketBase parent
Definition at line 820 of file ksocketdevice.cpp. References create(), and KSocketDevice().

KSocketDevice * KSocketDevice::createDefault | ( | KSocketBase * | parent,
|  | int | capabilities
| ) | `[static]`

  | This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. This will create an object only if the requested capabilities match. Parameters:
  | parent | the parent
  | capabilities | the requested capabilities
Definition at line 835 of file ksocketdevice.cpp. References QMap::constBegin(), and QMap::constEnd().

KSocketDeviceFactoryBase * KSocketDevice::setDefaultImpl | ( | KSocketDeviceFactoryBase * | factory | ) | `[static]`

  | Sets the default KSocketDevice implementation to use and return the old factory. Parameters:
  | factory | the factory object for the implementation
Definition at line 852 of file ksocketdevice.cpp.

void KSocketDevice::addNewImpl | ( | KSocketDeviceFactoryBase * | factory,
|  | int | capabilities
| ) | `[static]`

| Adds a factory of KSocketDevice objects to the list, along with its capabilities flag. Definition at line 860 of file ksocketdevice.cpp. References QMap::contains(), and QMap::insert().

## Member Data Documentation

int KNetwork::KSocketDevice::m_sockfd`[protected]`

| The socket file descriptor. It is used throughout the implementation and subclasses. Definition at line 95 of file ksocketdevice.h. Referenced by accept(), bind(), bytesAvailable(), close(), connect(), create(), createNotifier(), disconnect(), exceptionNotifier(), listen(), localAddress(), peekBlock(), peerAddress(), poll(), readBlock(), readNotifier(), setSocketOptions(), socket(), waitForMore(), writeBlock(), and writeNotifier().

The documentation for this class was generated from the following files:

- ksocketdevice.h
- ksocketdevice.cpp

This file is part of the documentation for kdecore Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:19:27 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003